--- /usr/bin/savelog	2009-02-17 06:27:53.000000000 +0900
+++ savelog	2009-11-14 23:36:12.000000000 +0800
@@ -185,9 +185,9 @@
 		continue
 	fi
 
-	# if not a file or empty, do nothing major
-	# (in the Debian version, we rotate even if empty by default)
-	if [ ! -s "$filename" ] && [ "$rotateifempty" != "yes" ]; then
+	# if file does not exist or is empty, and we've been told to not rotate
+	# empty files, create if requested and skip to the next file.
+	if [ ! -s "$filename" ] && [ "$rotateifempty" = "no" ]; then
 		# if -t was given and it does not exist, create it
 		if test -n "$touch" && [ ! -f "$filename" ]; then 
 			touch -- "$filename"
@@ -199,6 +199,16 @@
 			fixfile "$filename"
 		fi
 		continue
+	# otherwise if the file does not exist and we've been told to rotate it
+	# anyway, create an empty file to rotate.
+	elif [ ! -e "$filename" ]; then
+		touch -- "$filename"
+		if [ "$?" -ne 0 ]; then
+			echo "$prog: could not touch $filename" 1>&2
+			exitcode=4
+			continue
+		fi
+		fixfile "$filename"
 	fi
 
  	# be sure that the savedir exists and is writable
